
#include <utility/nRF24L01.h>
//#include <utility/RF24.h>
#include <OneWire.h>
#include <utility/RF24_config.h>
#include <SPI85.h>
#include <avr/sleep.h>
#include <MySensor.h>
#include <avr/wdt.h>
#include <EEPROM.h>

#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif

#define CHILD_ID 1
#define BODS 7                   //BOD Sleep bit in MCUCR
#define BODSE 2                  //BOD Sleep enable bit in MCUCR


int f_wdt = 0;
byte i,g = 0;
byte data[12];
int16_t raw;
int delay_t;
int new_id;
//int valore;

MySensor gw;
MyMessage msg(CHILD_ID,V_TEMP);
void setup()  
{ 


  cbi(ADCSRA,ADEN);                    // switch Analog to Digitalconverter OFF

  gw.begin(incomingMessage, AUTO, false, false);

  //gw.sendSketchInfo("T000000001",""); 	

  gw.present(CHILD_ID, S_TEMP); 

  delay_t = EEPROM.read(EEPROM_LOCAL_CONFIG_ADDRESS);
  if (delay_t == 0xFF)  delay_t=3;

  delay(30000);   
  gw.process(); 

  MCUSR &= ~(1<<WDRF);
  // start timed sequence
  WDTCR |= (1<<WDCE) | (1<<WDE);
  // set new watchdog timeout value
  WDTCR = 49;
  WDTCR |= _BV(WDIE);

}

void loop() 
{
  if (f_wdt>=delay_t){  //15 = 2 MINUTI         39) {  // wait for timed out watchdog / flag is set when a watchdog timeout occurs
    f_wdt=0;       // reset flag

    OneWire ds(PB0);  // on pin 10
    ds.reset();
    ds.skip();       // skip

      ds.write(0x44,1);        // start conversion, with parasite power on at the end

    delay(1000);     // maybe 750ms is enough, maybe not

    ds.reset();
    ds.skip();       // skip

      ds.write(0xBE);         // Read Scratchpad

    for ( i = 0; i < 9; i++) {           // we need 9 bytes
      data[i] = ds.read();
    }

    // Convert the data to actual temperature
    // because the result is a 16 bit signed integer, it should
    // be stored to an "int16_t" type, which is always 16 bits
    // even when compiled on a 32 bit processor.
    //raw = (data[1] << 8) | data[0];

    gw.send(msg.set((data[1] << 8) | data[0]));  

  }
  gw.sleep(0);
  digitalWrite(PB3,LOW);  
  digitalWrite(PB0,HIGH);

  system_sleep();
  //digitalWrite(PB4,LOW);  
}

void system_sleep() {
  //cbi(ADCSRA,ADEN);                    // switch Analog to Digitalconverter OFF

  set_sleep_mode(SLEEP_MODE_PWR_DOWN); // Set sleep mode 

  sleep_mode();                        // System sleeps here

}


// Watchdog Interrupt Service / is executed when watchdog timed out
ISR(WDT_vect) {
  f_wdt++;  // set global flag
}




void incomingMessage(const MyMessage &message) {
  if (message.type == V_VAR1) {
    //MyMessage msg(CHILD_ID,V_VAR1);
    delay_t = message.getInt();
    EEPROM.write(EEPROM_LOCAL_CONFIG_ADDRESS, delay_t);
    //gw.send(msg.set(delay_t)); 
  } 
  if (message.type == V_VAR2) {
    new_id = message.getInt();
    //EEPROM.write(EEPROM_NODE_ID_ADDRESS, new_id);
    EEPROM.write(EEPROM_NODE_ID_ADDRESS, new_id);
    setup();
    //gw.send(msg.set(new_id));
  }


}



